package com.google.cv;

import java.io.PrintStream;
import java.util.Hashtable;
import java.util.Vector;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

public class Entry extends Canvas {

    protected Image entryImage;
    protected Graphics entryGraphics;
    protected int lastX = -1;
    protected int lastY = -1;
    protected Sample sample;
    protected int downSampleLeft;
    protected int downSampleRight;
    protected int downSampleTop;
    protected int downSampleBottom;
    protected double ratioX;
    protected double ratioY;
    protected int[] pixelMap;
    int hc = 5;
    int vc = 7;
    int cmarker = -65536;
    //набор символов
    public String[] HANDWRITING = null;///{"ABCDEFGHIJKLMNOPQRSTUVWXYZ"};
    //маска
    int[][] mask = null;
    /*
     {
     {0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1},
     {1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0},
     {0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0},
     {1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0},
     {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1},
     {1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0},
     {0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0},
     {1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1},
     {0, 0, 1, 0, 0,
     0, 0, 1, 0, 0,
     0, 0, 1, 0, 0,
     0, 0, 1, 0, 0,
     0, 0, 1, 0, 0},
     {0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0},
     {1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 1},
     {1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1},
     {1, 0, 0, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1},
     {1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 1, 0, 1, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1},
     {0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0},
     {1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0},
     {0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 0, 0, 0},
     {1, 1, 1, 1, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 1},
     {0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0},
     {1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0},
     {
     1, 0, 0, 0, 1,
     1, 0, 0, 0, 1,
     1, 0, 0, 0, 1,
     0, 1, 0, 1, 0,
     0, 1, 1, 1, 0},
     {
     1, 0, 0, 0, 1,
     0, 1, 0, 1, 0,
     0, 1, 0, 1, 0,
     0, 1, 1, 1, 0,
     0, 0, 1, 0, 0},
     {1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0},
     {1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1},
     {1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0},
     {1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 1}
     };
     */
    Vector v = new Vector();
    String st = "";

    public Entry() {
        setSample(new Sample(this.hc, this.vc));
    }

    protected void initImage() {
        this.entryImage = Image.createImage(getWidth(), getHeight());

        this.pixelMap = new int[getWidth() * getHeight()];
        this.entryGraphics = this.entryImage.getGraphics();

        clear();
    }

    public void paint(Graphics g) {
        if (this.entryImage == null) {
            initImage();
        }
        g.drawImage(this.entryImage, 0, 0, 20);
        g.setColor(-16777216);
        g.drawRect(0, 0, getWidth() - 1, getHeight() - 1);
        g.setColor(-16777216);
        g.drawRect(this.downSampleLeft, this.downSampleTop, this.downSampleRight - this.downSampleLeft, this.downSampleBottom - this.downSampleTop);
    }

    protected void pointerPressed(int x, int y) {
        this.lastX = x;
        this.lastY = y;
    }

    protected void pointerReleased(int x, int y) {
    }
//рисуем линию

    protected void pointerDragged(int x, int y) {
        this.entryGraphics.setColor(this.cmarker);
        this.entryGraphics.drawLine(this.lastX, this.lastY, x, y);

        this.entryGraphics.drawLine(this.lastX + 1, this.lastY, x + 1, y);
        this.entryGraphics.drawLine(this.lastX + 1, this.lastY + 1, x + 1, y + 1);
        this.entryGraphics.drawLine(this.lastX, this.lastY + 1, x, y + 1);

        this.entryGraphics.drawLine(this.lastX + 2, this.lastY, x + 2, y);
        this.entryGraphics.drawLine(this.lastX + 2, this.lastY + 2, x + 2, y + 2);
        this.entryGraphics.drawLine(this.lastX, this.lastY + 2, x, y + 2);

        this.lastX = x;
        this.lastY = y;
        repaint();
    }

    public void setSample(Sample s) {
        this.sample = s;
    }

    public Sample getSample() {
        return this.sample;
    }
//пердобработка, берем нарисованый символ, обрезаем по размерам краев, растягиваем на весь экран

    public void preprocess() {

        int xleft = getWidth();
        int xright = 0;
        int ytop = getHeight();
        int ydon = 0;

        int[] pix = new int[getWidth() * getHeight()];

        this.entryImage.getRGB(pix, 0, getWidth(), 0, 0, getWidth(), getHeight());

        for (int y = 0; y < getHeight(); y++) {
            for (int x = 0; x < getWidth(); x++) {
                if (pix[y * getWidth() + x] == 0xff000000) {
                    pix[y * getWidth() + x] = -1;
                    this.entryGraphics.setColor(-1);
                    this.entryGraphics.drawLine(x, y, x, y);

                } else if (pix[y * getWidth() + x] == this.cmarker) {

                    if (x < xleft) {
                        xleft = x;
                    }
                    if (x > xright) {
                        xright = x;
                    }
                    if (y < ytop) {
                        ytop = y;
                    }
                    if (y > ydon) {
                        ydon = y;
                    }
                }

            }

        }



        Image img = Image.createImage((xright - xleft), (ydon - ytop));
        Graphics gr = img.getGraphics();
        int[] rgb = new int[((xright - xleft)) * ((ydon - ytop))];


        this.entryImage.getRGB(rgb, 0, (xright - xleft), xleft, ytop, (xright - xleft), (ydon - ytop));

        gr.drawRGB(rgb, 0, (xright - xleft), 0, 0, (xright - xleft), (ydon - ytop), true);
        rgb = null;

        img = resize(img);

        this.entryGraphics.setColor(-1);
        this.entryGraphics.fillRect(0, 0, getWidth(), getHeight());
        this.entryGraphics.drawImage(img, getWidth() / 2, getHeight() / 2, Graphics.HCENTER | Graphics.VCENTER);

    }
//ресайз

    public Image resize(Image original, int newWidth, int newHeight) {

        final int width = original.getWidth();

        final int height = original.getHeight();
        int[] pixels = new int[width * height];

        original.getRGB(pixels, 0, width, 0, 0, width, height);

        int out[] = new int[newWidth * newHeight];
        for (int y = 0; y < newHeight; y++) {
            int dy = (y * height) / newHeight;
            for (int x = 0; x < newWidth; x++) {
                int dx = (x * width) / newWidth;
                out[newWidth * y + x] = pixels[width * dy + dx];
            }
        }

        return (Image.createRGBImage(out, newWidth, newHeight, true));

    }

    public static boolean x(int x, int y) {

        return x > y;
    }
//сортировка шелла

    public static int[] shellSort(int[] arr, boolean reverse) {
        for (int increment = arr.length / 2; increment > 0; increment = (increment == 2 ? 1
                        : (int) Math.floor(increment / 2.2))) {
            for (int i = increment; i < arr.length; i++) {
                int temp = arr[i];
                for (int j = i; j >= increment
                        && x(arr[j - increment], temp); j -= increment) {
                    arr[j] = arr[j - increment];
                    arr[j - increment] = temp;
                }
            }
        }


        if (reverse) {
            return reverse(arr);
        }

        return arr;
    }
// по названию понятно.Возвращает массив "задом наперед"

    public static int[] reverse(int[] a) {
        int[] b = new int[a.length];
        int j = a.length;
        for (int i = 0; i < j; i++) {
            b[(j - 1) - i] = a[i];
        }
        return b;
    }
//сортируем вектор

    public Vector sortLong(Vector v) {
        int l[] = new int[v.size()];
        ///System.out.println("in");
        for (int i = 0; i < l.length; i++) {
            l[i] = Integer.parseInt((String) v.elementAt(i));
            ///System.out.println(l[i]);
        }
        // int l1[] = l;
        l = shellSort(l, true);

        v = new Vector();
        //System.out.println("out");
        for (int i = 0; i < l.length; i++) {
            v.addElement("" + (l[i]));
            //System.out.println(l[i]);
        }
        return v;
    }
//обрабатываем экран

    public void process() {
        preprocess();


        this.st = "";


        this.v.removeAllElements();


        SampleData data = this.sample.getData();
        for (int y = 0; y < data.getHeight(); y++) {


            for (int x = 0; x < data.getWidth(); x++) {
                Image img = Image.createImage(this.entryImage, x * this.sample.hcell, y * this.sample.vcell, this.sample.hcell, this.sample.vcell, 0);

                int[] pix = new int[img.getWidth() * img.getHeight()];

                img.getRGB(pix, 0, img.getWidth(), 0, 0, img.getWidth(), img.getHeight());

                for (int i = 0; i < pix.length; i++) {
                    if (pix[i] == this.cmarker) {
                        this.sample.proc[x][y] = true;

                    }




                }

            }

        }

        int xleft = data.getWidth();
        //int xright = 0;
        int ytop = data.getHeight();
        //int ydon = 0;

        int[] getmask = new int[xleft * ytop];

        int i = 0;
        for (int y = 0; y < ytop; y++) {
            String str = "";
            for (int x = 0; x < xleft; x++) {
                getmask[i] = (this.sample.proc[x][y] ? 1 : 0);
                str = str + getmask[i] + ",";
                i++;
            }
            System.out.println(str);
        }



        i = 0;



        Vector t = new Vector();
        for (int i1 = 0; i1 < this.mask.length; i1++) {
            int[] tr = this.mask[i1];
            i = 0;

            for (int i2 = 0; i2 < getmask.length; i2++) {
                if (getmask[i2] == tr[i2]) {
                    i++;
                }

            }


            //System.out.println(cc + "/" + k);
            //System.out.println(k * 100 / cc);
            int proc = i * 100 / getmask.length;
            //int proc = k * 100 / cc;
            this.v.addElement("" + proc);
            t.addElement(proc + "%, " + this.HANDWRITING[i1]);
            setTitle("Match " + proc + "%, " + this.HANDWRITING[i1]);
        }

        if (this.v.size() != 0) {
            v = sortLong(v);


            String et = (String) v.elementAt(0);
            System.out.println("*****" + et);
            for (int i2 = 0; i2 < v.size(); i2++) {
                System.out.println("*****" + (String) t.elementAt(i2));
                if (((String) t.elementAt(i2)).startsWith(et)) {
                    setTitle("Match " + (String) t.elementAt(i2));
                }
            }
        }
        System.out.println("*****Finish");
    }
//ресет данных

    public void reset() {
        SampleData data = this.sample.getData();

        for (int y = 0; y < data.getHeight(); y++) {
            for (int x = 0; x < data.getWidth(); x++) {
                this.sample.proc[x][y] = false;
            }
        }
        clear();
        this.sample.data.clear();
    }
//очистка экрана

    public void clear() {
        this.entryGraphics.setColor(-1);
        this.entryGraphics.fillRect(0, 0, getWidth(), getHeight());
        this.sample.paint(this.entryGraphics);
        this.downSampleBottom = (this.downSampleTop = this.downSampleLeft = this.downSampleRight = 0);
        repaint();
    }
//учим в школе алфавит

    public void train() {
        setTitle("Training");

        Font font = (Font.getFont(Font.FACE_SYSTEM, Font.STYLE_ITALIC,
                Font.SIZE_LARGE));/// fonts[f];

        String abc = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";/// + "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toLowerCase()+"+-=1234567890";

        int sz = abc.length();
        int off = 0;
        HANDWRITING = new String[sz - off];
        mask = new int[sz - off][];


        for (int ik = off; ik < sz; ik++) {
            char c = abc.charAt(ik);
            Image img = Image.createImage(font.charWidth(c) + 2, font.getHeight() + 2);
            Graphics gr = img.getGraphics();

            gr.setColor(-1);
            gr.fillRect(0, 0, img.getWidth(), img.getHeight());
            gr.setColor(this.cmarker);
            gr.drawChar(c, 1, 1, 0);
            int xleft = img.getWidth();
            int xright = 0;
            int ytop = img.getHeight();
            int ydon = 0;

            int[] pix = new int[img.getWidth() * img.getHeight()];
            ///this.entryImage = smoothing(this.entryImage);
            img.getRGB(pix, 0, img.getWidth(), 0, 0, img.getWidth(), img.getHeight());

            for (int y = 0; y < img.getHeight(); y++) {
                for (int x = 0; x < img.getWidth(); x++) {

                    if (pix[y * img.getWidth() + x] == this.cmarker) {

                        if (x < xleft) {
                            xleft = x;
                        }
                        if (x > xright) {
                            xright = x;
                        }
                        if (y < ytop) {
                            ytop = y;
                        }
                        if (y > ydon) {
                            ydon = y;
                        }
                    }

                }

            }
            pix = null;
            xright = xright + 1;
            ydon = ydon + 1;

            Image img3 = Image.createImage((xright - xleft), (ydon - ytop));
            gr = img3.getGraphics();
            int[] rgb = new int[((xright - xleft)) * ((ydon - ytop))];


            img.getRGB(rgb, 0, (xright - xleft), xleft, ytop, (xright - xleft), (ydon - ytop));

            gr.drawRGB(rgb, 0, (xright - xleft), 0, 0, (xright - xleft), (ydon - ytop), true);
            rgb = null;
            img3 = resize(img3);

            this.entryGraphics.setColor(-1);
            this.entryGraphics.fillRect(0, 0, getWidth(), getHeight());
            this.entryGraphics.drawImage(img3, getWidth() / 2, getHeight() / 2, Graphics.HCENTER | Graphics.VCENTER);


            this.repaint();



            SampleData data = this.sample.getData();
            for (int y = 0; y < data.getHeight(); y++) {


                for (int x = 0; x < data.getWidth(); x++) {
                    img = Image.createImage(this.entryImage, x * this.sample.hcell, y * this.sample.vcell, this.sample.hcell, this.sample.vcell, 0);

                    pix = new int[img.getWidth() * img.getHeight()];

                    img.getRGB(pix, 0, img.getWidth(), 0, 0, img.getWidth(), img.getHeight());

                    for (int i = 0; i < pix.length; i++) {
                        if (pix[i] == this.cmarker) {
                            this.sample.proc[x][y] = true;

                        }




                    }

                }

            }

            xleft = data.getWidth();
            
            ytop = data.getHeight();
           

            int[] getmask = new int[xleft * ytop];

            int i = 0;
            for (int y = 0; y < ytop; y++) {
                String str = "";
                for (int x = 0; x < xleft; x++) {
                    getmask[i] = (this.sample.proc[x][y] ? 1 : 0);
                    str = str + getmask[i] + ",";
                    i++;
                }
                System.out.println(str);
            }
            System.out.println(c);

            reset();
            HANDWRITING[ik - off] = new String("" + c);
            mask[ik - off] = getmask;

        }

        setTitle("Done");
    }

    //растягиваем на экран в зависимости от начальных данных
    public Image resize(Image img) {

        if (img.getWidth() < img.getHeight() && img.getHeight() / img.getWidth() > 3) {

            img = resize(img, img.getWidth() * getHeight() / img.getHeight(), getHeight());//y=100, x=..., h=123, v = 80; x = y*v/h;

        } else if (img.getWidth() > img.getHeight() && img.getWidth() / img.getHeight() > 3) {

            img = resize(img, getWidth(), img.getHeight() * getWidth() / img.getWidth());//y=100, x=..., h=123, v = 80; x = y*v/h;

        } else {
            img = resize(img, getWidth(), getHeight());//y=100, x=..., h=123, v = 80; x = y*v/h;
        }

        return img;
    }
}
