package com.google.cv;

import javax.microedition.lcdui.*;

//import java.awt.*;
/**
 * Java Neural Network Example Handwriting Recognition Copyright 2005 by Heaton
 * Research, Inc. by Jeff Heaton (http://www.heatonresearch.com) 10-2005
 * ------------------------------------------------- This source code is
 * copyrighted. You may reuse this code in your own compiled projects. However,
 * if you would like to redistribute this source code in any form, you must
 * obtain permission from Heaton Research. (support@heatonresearch.com).
 * -------------------------------------------------
 *
 * This class displays a character in a "downsampled" form.
 *
 * ------------------------------------------------- Want to learn more about
 * Neural Network Programming in Java? Have a look at our e-book:
 *
 * http://www.heatonresearch.com/articles/series/1/
 *
 * @author Jeff Heaton (http://www.jeffheaton.com)
 * @version 1.0
 */
public class Sample extends Canvas {

    /**
     * The image data.
     */
    SampleData data;
    /**
     * The constructor.
     *
     * @param width The width of the downsampled image
     * @param height The height of the downsampled image
     */
    int vcell;// = getHeight() / data.getHeight();
    int hcell;/// = getWidth() / data.getWidth();
    boolean[][] proc;//= new boolean[width][height];

    public Sample(int width, int height) {
        data = new SampleData(' ', width, height);
        vcell = getHeight() / data.getHeight();
        hcell = getWidth() / data.getWidth();
        proc = new boolean[width][height];
        System.out.println(vcell + "*" + hcell);
        //this.setFullScreenMode(true);
    }

    /**
     * The image data object.
     *
     * @return The image data object.
     */
    SampleData getData() {
        return data;
    }

    /**
     * Assign a new image data object.
     *
     * @param data The image data object.
     */
    void setData(SampleData data) {
        this.data = data;
    }

    /**
     * @param g Display the downsampled image.
     */
    public void paint(Graphics g) {
        if (data == null) {
            return;
        }

        int x, y;


        //g.setColor(0xFFFFFF);
        //g.fillRect(0, 0, getWidth(), getHeight());

        g.setColor(0xff000000);
        for (y = 0; y < data.getHeight(); y++) {
            g.drawLine(0, y * vcell, getWidth(), y * vcell);
        }
        for (x = 0; x < data.getWidth(); x++) {
            g.drawLine(x * hcell, 0, x * hcell, getHeight());
        }

        for (y = 0; y < data.getHeight(); y++) {
            for (x = 0; x < data.getWidth(); x++) {

                //if (data.getData(x, y)) {
                if (proc[(x)][(y)]) {
                    g.setColor(0xff00ff00);
                    g.fillRect(x * hcell, y * vcell, hcell, vcell);
                    //System.out.println(data.getLetter());
                }
            }
        }

        g.setColor(0xff000000);
        g.drawRect(0, 0, getWidth() - 1, getHeight() - 1);

    }
}